library super_sockets.name_generator;

import "dart:io";
import "package:path/path.dart" as path;

class NameGenerator {
  Set<String> _taken;
  int _cursor;
  List<String> _names;
  
  String generate() {
    String temp, name;
    int i = 0;
    if (_cursor >= _names.length) {
      _cursor = 0;
      _names.shuffle();
    }
    
    name = temp = _names[_cursor];
    while (_taken.contains(name)) {
      name = "${temp}${i}";
      i++;
    }

    _cursor++;
    
    _taken.add(name);
    return name;
  }
  
  void free(String name) {
    if (_taken.contains(name)) {
      _taken.remove(name);
    }
  }
  
  NameGenerator() {
    File fo = new File("packages/super_sockets/resources/names.txt");
    
    this._names = fo.readAsLinesSync();
    this._cursor = 0;
    this._taken = new Set<String>();
    this._names.shuffle();
  }
}