library super_sockets.socket_server;

import 'dart:io';
import 'dart:async';
import 'name_generator.dart';
import 'socket_user.dart';

class SocketServer{
  StreamController<SocketUser> _controller;
  NameGenerator _ng;
  void _onUpgrade(WebSocket socket) {
    SocketUser su;
    if (_ng == null) {
      su = new SocketUser(socket);
    } else {
      su = new SocketUser(socket, _ng.generate());
    }
    _controller.add(su);
  }
  
  void _onConnection(HttpRequest request) {
    WebSocketTransformer.upgrade(request)
    .then(_onUpgrade);
  }
  
  void _onInitServer(HttpServer server) {
    server.listen(_onConnection);
  }
  
  SocketServer(int port, [NameGenerator ng = null]) {
    this._ng = ng;
    this._controller = new StreamController<SocketUser>();
    
    HttpServer.bind('127.0.0.1', port).then(_onInitServer);
  }
  
  Stream<SocketUser> get users {
    return _controller.stream;
  }
}
