library socket_user.socket_user_group;

import 'dart:async';
import 'socket_user.dart';
import 'stream_enhancer.dart';
import 'package:json_object/json_object.dart';

class SocketUserGroup {
  Set<SocketUser> _userSet;
  Map<String, WriteableStreamEnhancer<JsonObject>> _router;
  
  void _ensureExistence(String type) {
    if (!_router.containsKey(type)) {
      var enhancer = new WriteableStreamEnhancer<JsonObject>.fromScratch();
      for (SocketUser su in _userSet) {
        enhancer.controller.addStream(su.messageStream(type));
      }
      _router[type] = enhancer;
    }
  }
  
  Future<JsonObject> receiveOne(String type) {
    _ensureExistence(type);
    return _router[type].next();
  }
  
  void addUser(SocketUser user) {
    for (String key in _router) {
      Stream<JsonObject> stream = user.messageStream(key);
      _router[key].controller.addStream(stream);
    }
    _userSet.add(user);
  }

  SocketUserGroup([Iterable<SocketUser> sui = null]) {
    this._router = new Map<String, StreamEnhancer<JsonObject>>();
    this._userSet = new Set<SocketUser>();
    if (sui != null) {
      for (SocketUser user in sui) {
        addUser(user);
      }
    }
  }
}